﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esempio.MVC
{
    public partial class View : UserControl
    {
        private Model _model;
        private Controller _controller;

        public View()
        {
            InitializeComponent();
        }

        public Model Model
        {
            get { return _model; }
            set
            {
                if (value != _model)
                {
                    if (_model != null)
                    {
                        //  Deregistrazione
                        _model.Changed -= OnModelChanged;
                    }
                    _model = value;
                    if (_model != null)
                    {
                        //  Registrazione
                        _model.Changed += OnModelChanged;
                        OnModelChanged(_model, EventArgs.Empty);
                    }
                }
            }
        }

        public Controller Controller
        {
            get { return _controller; }
            set { _controller = value; }
        }

        protected virtual void OnModelChanged(object sender, EventArgs e)
        {
        }
    }
}
