﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Esempio.MVP
{
    class Presenter2 : Presenter
    {
        private readonly IColorView _view;

        public Presenter2(IColorView view)
        {
            if (view == null)
                throw new ArgumentNullException("view");
            _view = view;
            _view.ColorChanged += new EventHandler(OnViewColorChanged);
        }

        protected override void OnModelChanged(object sender, EventArgs e)
        {
            _view.Color = Model.Color;
        }

        private void OnViewColorChanged(object sender, EventArgs e)
        {
            Model.Color = _view.Color;
        }
    }
}
