﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace Esempio.MVP
{
    class Presenter3 : Presenter
    {
        private readonly Button _button;
        private readonly Random _random = new Random();

        public Presenter3(Button button)
        {
            if (button == null)
                throw new ArgumentNullException("button");
            _button = button;
            _button.Click += new EventHandler(OnButtonClick);
        }

        protected override void OnModelChanged(object sender, EventArgs e)
        {
            _button.BackColor = Model.Color;
        }

        private void OnButtonClick(object sender, EventArgs e)
        {
            Model.Color = Color.FromArgb(Model.Color.A, _random.Next(0, 255), _random.Next(0, 255), _random.Next(0, 255));
        }
    }
}
