﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace Esempio.MVP
{
    class Presenter4 : Presenter
    {
        private readonly ComboBox _comboBox;

        public Presenter4(ComboBox comboBox)
        {
            if (comboBox == null)
                throw new ArgumentNullException("comboBox");
            _comboBox = comboBox;
            _comboBox.SelectedIndexChanged += ComboBoxSelectedIndexChanged;
        }

        protected override void OnModelChanged(object sender, EventArgs e)
        {
            Color color = Model.Color;
            if (color.ToKnownColor() != 0)
            {
                _comboBox.SelectedItem = color.ToKnownColor();
            }
            else
            {
                foreach (KnownColor knownColor in Enum.GetValues(typeof(KnownColor)))
                {
                    if (KnownColor.AliceBlue <= knownColor && knownColor <= KnownColor.YellowGreen)
                    {
                        Color currentColor = Color.FromKnownColor(knownColor);
                        if (color.A == currentColor.A &&
                            color.R == currentColor.R &&
                            color.G == currentColor.G &&
                            color.B == currentColor.B)
                        {
                            _comboBox.SelectedItem = knownColor;
                            break;
                        }
                    }
                }
            }
        }

        private void ComboBoxSelectedIndexChanged(object sender, EventArgs e)
        {
            Model.Color = Color.FromKnownColor((KnownColor) _comboBox.SelectedValue);
        }
    }
}
