﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esempio.MVP
{
    public partial class View2 : UserControl, IColorView
    {
        public event EventHandler ColorChanged;

        public View2()
        {
            InitializeComponent();
        }

        public Color Color
        {
            get { return Color.FromArgb(_trackBarA.Value, _trackBarR.Value, _trackBarG.Value, _trackBarB.Value); }
            set
            {
                if (value != Color)
                {
                    _trackBarA.Value = value.A;
                    _trackBarR.Value = value.R;
                    _trackBarG.Value = value.G;
                    _trackBarB.Value = value.B;
                    RefreshTextBox();
                }
            }
        }

        private void TrackBar_Scroll(object sender, EventArgs e)
        {
            RefreshTextBox();
            if (ColorChanged != null)
                ColorChanged(this, EventArgs.Empty);
        }

        private void RefreshTextBox()
        {
            _textBox.Text = Color.ToString();
        }
    }
}
