﻿using System;
using System.Drawing;

namespace Esempio
{
    public class Model
    {
        private Color _color = Color.White;

        public event EventHandler Changed;

        public Color Color
        {
            get { return _color; }
            set
            {
                if (value != _color)
                {
                    _color = value;
                    OnChanged(EventArgs.Empty);
                }
            }
        }

        protected virtual void OnChanged(EventArgs e)
        {
            if (Changed != null)
                Changed(this, e);
        }
    }
}
